Set Implicit Arguments.
Unset Strict Implicit.
Unset Printing Implicit Defensive.

Require Import proofs.

(** Preserving [eq0] *)
Create HintDb propereq0.
Lemma ka_eq_eq0 : Proper (ka_eq ==> Logic.eq) eq0.
Proof.
  intros e f E; induction E;simpl;auto with bool.
  now destruct (eq0 e);simpl.
  now destruct (eq0 e); destruct (eq0 f); destruct (eq0 g);simpl.
  now destruct (eq0 e); destruct (eq0 f); destruct (eq0 g);simpl.
Qed.
Hint Resolve ka_eq_eq0 : propereq0.
Theorem eq_eq0 ax :
  Proper (ax ==> Logic.eq) eq0 -> Proper (eq ax ==> Logic.eq) eq0.
Proof.
  intros H e f E; induction E;
  simpl in *;auto with bool;try (f_equal;tauto).
  now eauto.
  now apply ka_eq_eq0.
  destruct H0;simpl in *;rewrite <- IHE at 2.
  now destruct (eq0 e); destruct (eq0 f); destruct (eq0 g);simpl.
  now destruct (eq0 e); destruct (eq0 f); destruct (eq0 g);simpl.
Qed.

Lemma ka_eq_t_eq0 : Proper (ka_eq_t ==> Logic.eq) eq0.
Proof. intros e f E;induction E;simpl;auto with bool. Qed.
Hint Resolve ka_eq_t_eq0 : propereq0.

Lemma ka_eq_u_eq0 : Proper (ka_eq_u ==> Logic.eq) eq0.
Proof. intros e f E;induction E;simpl;auto with bool. Qed.
Hint Resolve ka_eq_u_eq0 : propereq0.

Lemma zero_ka_t_eq0 : Proper (zero_ka_t ==> Logic.eq) eq0.
Proof. intros e f H;induction H; simpl in *;auto with bool;
       try (f_equal;tauto). now destruct (eq0 e);simpl. Qed.
Hint Resolve zero_ka_t_eq0 : propereq0.

Lemma zero_ka_u_eq0 : Proper (zero_ka_u ==> Logic.eq) eq0.
Proof. intros e f H;induction H; simpl in *;auto with bool;
       try (f_equal;tauto). now destruct (eq0 e);simpl. Qed.
Hint Resolve zero_ka_u_eq0 : propereq0.

Lemma zero_perm_t_eq0 : Proper (zero_perm_t ==> Logic.eq) eq0.
Proof. intros e f H;induction H; simpl in *;auto with bool;
       try (f_equal;tauto). Qed.
Hint Resolve zero_perm_t_eq0 : propereq0.

Lemma zero_perm_u_eq0 : Proper (zero_perm_u ==> Logic.eq) eq0.
Proof. intros e f H;induction H; simpl in *;auto with bool;
       try (f_equal;tauto). Qed.
Hint Resolve zero_perm_u_eq0 : propereq0.

Lemma zero_nom_t_eq0 : Proper (zero_nom_t ==> Logic.eq) eq0.
Proof. intros e f H;induction H; simpl in *;auto with bool;
       try (f_equal;tauto). Qed.
Hint Resolve zero_nom_t_eq0 : propereq0.

Lemma zero_nom_u_eq0 : Proper (zero_nom_u ==> Logic.eq) eq0.
Proof. intros e f H;induction H; simpl in *;auto with bool;
       try (f_equal;tauto). Qed.
Hint Resolve zero_nom_u_eq0 : propereq0.

Lemma eq_nom_typed_p_eq0 : Proper (eq_nom_typed_p ==> Logic.eq) eq0.
Proof. intros e f E;induction E;simpl;auto with bool. Qed.
Hint Resolve eq_nom_typed_p_eq0 : propereq0.
Lemma eq_nom_typed_np_eq0 : Proper (eq_nom_typed_np ==> Logic.eq) eq0.
Proof. intros e f E;induction E;simpl; auto using eq0_apply_perm. Qed.
Hint Resolve eq_nom_typed_np_eq0 : propereq0.
Lemma eq_nom_typed_eq0 : Proper (eq_nom_typed ==> Logic.eq) eq0.
Proof. intros e f E;induction E;simpl;auto with bool. Qed.
Hint Resolve eq_nom_typed_eq0 : propereq0.

Lemma eq_nom_untyped_p_eq0 : Proper (eq_nom_untyped_p ==> Logic.eq) eq0.
Proof. intros e f E;induction E;simpl;auto with bool. Qed.
Hint Resolve eq_nom_untyped_p_eq0 : propereq0.
Lemma eq_nom_untyped_np_eq0 :
  Proper (eq_nom_untyped_np ==> Logic.eq) eq0.
Proof. intros e f E;induction E;simpl;auto using eq0_apply_perm. Qed.
Hint Resolve eq_nom_untyped_np_eq0 : propereq0.
Lemma eq_nom_untyped_eq0 : Proper (eq_nom_untyped ==> Logic.eq) eq0.
Proof. intros e f E;induction E;simpl;auto with bool. Qed.
Hint Resolve eq_nom_untyped_eq0 : propereq0.

Lemma eq_perm_elim_eq0 : Proper (eq_perm_elim ==> Logic.eq) eq0.
Proof. intros e f E;induction E;simpl;auto with bool. Qed.
Hint Resolve eq_perm_elim_eq0 : propereq0.

Lemma eq_ν_smpl_eq0: Proper (eq_ν_smpl ==> Logic.eq) eq0.
Proof. intros e f E;induction E;simpl;auto with bool. Qed.
Hint Resolve eq_ν_smpl_eq0 : propereq0.
Lemma eq_ω_smpl_eq0: Proper (eq_ω_smpl ==> Logic.eq) eq0.
Proof. intros e f E;induction E;simpl;auto with bool. Qed.
Hint Resolve eq_ω_smpl_eq0 : propereq0.

Lemma  eq_perm_eq0 : Proper (eq_perm ==> Logic.eq) eq0.
Proof. intros e f E;induction E;simpl;auto with bool. Qed.
Hint Resolve eq_perm_eq0 : propereq0.
Lemma  eq_perm_ω_eq0 : Proper (eq_perm_ω ==> Logic.eq) eq0.
Proof. intros e f E;induction E;simpl;auto with bool. Qed.
Hint Resolve eq_perm_ω_eq0 : propereq0.
Lemma zero_eq_u_eq0 : Proper (zero_eq_u ==> Logic.eq) eq0.
Proof.
  intros e f [[H|H]|H];[apply zero_ka_u_eq0
                       |apply zero_perm_u_eq0
                       |apply zero_nom_u_eq0];assumption.
Qed.
Hint Resolve zero_eq_u_eq0 : propereq0.
Lemma zero_eq_t_eq0 : Proper (zero_eq_t ==> Logic.eq) eq0.
Proof.
  intros e f [[H|H]|H];[apply zero_ka_t_eq0
                       |apply zero_perm_t_eq0
                       |apply zero_nom_t_eq0];assumption.
Qed.
Hint Resolve zero_eq_t_eq0 : propereq0.

(** Misc. *)
Lemma eq0_proof_untyped :
  forall e, untyped e -> eq0 e = true ->
            zero_eq_u  ⊢ e ≡ 0.
Proof.
  induction e; simpl;intros U E; discriminate || tauto || auto.
  - apply Bool.andb_true_iff in E as (E1 & E2);
    apply IHe1 in E1;apply IHe2 in E2;intuition;
    etransitivity;[apply eq_plus|];eauto.
  - apply Bool.orb_true_iff in E as [E1 | E2];
    [apply IHe1 in E1|apply IHe2 in E2];intuition;
    (etransitivity;[apply eq_times|];eauto 6).
  - apply IHe in E; intuition;transitivity (ν a 0);auto.
    prove_ax.
  - apply IHe in E; intuition;transitivity (‹ p › 0);auto.
Qed.
Lemma eq0_untyped_refl :
  forall e, untyped e ->reflect (zero_eq_u  ⊢ e ≡ 0) (eq0 e).
Proof.
  pose proof (eq_eq0 zero_eq_u_eq0) as aux.
  induction e; simpl;try tauto;intros U;eauto.
  - apply ReflectT;auto.
  - apply ReflectF;intro E;apply aux in E.
    simpl in E;discriminate.
  - apply ReflectF;intro E;apply aux in E.
    simpl in E;discriminate.
  - apply ReflectF;intro E;apply aux in E.
    simpl in E;discriminate.
  - destruct U as (U1 & U2);apply IHe1 in U1;apply IHe2 in U2.
    clear IHe1 IHe2.
    revert U1 U2; remember (eq0 e1) as b1; remember (eq0 e2) as b2.
    destruct b1;intro E1;inversion E1;
    destruct b2;intro E2;inversion E2.
    * simpl;apply ReflectT;eauto.
    * simpl;apply ReflectF. intro h; apply aux in h;simpl in h.
       apply Bool.andb_true_iff in h as (_&h). congruence.
    * simpl;apply ReflectF. intro h; apply aux in h;simpl in h.
       apply Bool.andb_true_iff in h as (h&_). congruence.
    * simpl;apply ReflectF. intro h; apply aux in h;simpl in h.
       apply Bool.andb_true_iff in h as (_&h). congruence.
  - destruct U as (U1 & U2);pose proof (IHe1 U1) as h1;
    pose proof (IHe2 U2) as h2; clear IHe1 IHe2; revert h1 h2.
    remember (eq0 e1) as b1; remember (eq0 e2) as b2.
    destruct b1;intro E1;inversion E1;
    destruct b2;intro E2;inversion E2.
    * simpl;apply ReflectT. rewrite H,H0; repeat eql;auto.
    * simpl;apply ReflectT. rewrite H; repeat eql;auto.
    * simpl;apply ReflectT. rewrite H0; repeat eql;auto.
    * simpl;apply ReflectF. intro h; apply aux in h;simpl in h.
       apply Bool.orb_true_iff in h as [h|h]; congruence.
  - pose proof (IHe U) as h; clear IHe; revert h;
    remember (eq0 e) as b1.
    destruct b1;intro E1;inversion E1.
    * simpl;apply ReflectF. intro h; apply aux in h;simpl in h.
       congruence.
    * simpl;apply ReflectF. intro h; apply aux in h;simpl in h.
       congruence.
  - pose proof (IHe U) as h; clear IHe; revert h;
    remember (eq0 e) as b1.
    destruct b1;intro E1;inversion E1.
    * simpl;apply ReflectT. rewrite H;prove_ax. 
    * simpl;apply ReflectF. intro h; apply aux in h;simpl in h.
       congruence.
  - apply IHe in U; clear IHe; revert U; remember (eq0 e) as b1.
    destruct b1;intro E1;inversion E1.
    * simpl;apply ReflectT. rewrite H;prove_ax. 
    * simpl;apply ReflectF. intro h; apply aux in h;simpl in h.
       congruence.
Qed.
Lemma eq0_proof_typed :
  forall e A, A ⊨ e -> eq0 e = true ->
              zero_eq_t ⊢ e ≡ ⊥ A.
Proof.
  induction e;intro A;simpl;intros T E;
  discriminate || tauto || auto.
  - apply Bool.andb_true_iff in E as (E1 & E2);intuition;
    (eapply IHe1 in E1 as ->;[|eassumption]);
    (eapply IHe2 in E2 as ->;[|eassumption]);prove_ax.
  - apply Bool.orb_true_iff in E as [E1 | E2];intuition;
    [eapply IHe1 in E1 as ->;[|eassumption]
    |eapply IHe2 in E2 as ->;[|eassumption]];prove_ax.
  - destruct T as (I&T);eapply IHe in E as ->;[|eassumption].
    transitivity (⊥ (rm a (a::A)));auto.
  - destruct T as (I&T);eapply IHe in E as ->;[|eassumption].
    transitivity (⊥ (a::(rm a A)));auto.
    eqr;prove_ax;simpl_in;tauto. 
  - eapply IHe in E as ->;[|eassumption].
    eql;eqr;apply eq_ax, eq_θ_bot;simpl_perm;auto.
Qed.

(** [rm0] preserves the semantics. *)  
Lemma rm0_eq_untyped :
  forall e, untyped e ->
            (zero_eq_u ∨ ka_eq_u) ⊢ e ≡ rm0 e.
Proof.
  induction e;simpl;intros (Ue & Uf)||intro U;(now intuition)||auto.
  - rewrite (IHe1 Ue),(IHe2 Uf)at 1.
    destr_posu (rm0 e1).
    transitivity (rm0 e2 + 0);auto;prove_ax.
    destr_posu (rm0 e2);prove_ax.
  - rewrite (IHe1 Ue),(IHe2 Uf)at 1.
    destr_posu (rm0 e1);auto 10 using untyped_rm0.
    destr_posu (rm0 e2);auto 10 using untyped_rm0.
  - rewrite (IHe U) at 1;destr_posu (rm0 e).
    eapply stronger_ax_proof;[|apply zero_star_is_one_u].
    autounfold;firstorder.
  - rewrite (IHe U) at 1;destr_posu (rm0 e); prove_ax.
  - rewrite (IHe U) at 1;destr_posu (rm0 e); prove_ax. 
Qed.

Lemma rm0_eq_typed :
  forall e A, A ⊨ e ->
              (zero_eq_t ∨ ka_eq_t) ⊢ e ≡ rm0 e.
Proof.
  induction e;simpl;intros A T;auto.
  - intuition. rewrite (IHe1 _ H),(IHe2 _ H0) at 1.
    destr_post (rm0 e1) A. simpl in T;rewrite <- T.
    transitivity (rm0 e2 + ⊥ A);auto;prove_ax; auto using typed_rm0.
    destr_post (rm0 e2) A;prove_ax;split;eauto;auto 10.
  - intuition. rewrite (IHe1 _ H),(IHe2 _ H0) at 1.
    destr_post (rm0 e1) A.
    simpl in T;rewrite <- T;prove_ax; auto using typed_rm0.
    destr_post (rm0 e2) A;prove_ax;split;eauto;auto 10.
  - rewrite (IHe _ T) at 1.
    destr_post (rm0 e) A.
    eapply stronger_ax_proof;[|apply zero_star_is_one_t].
    autounfold;firstorder.
  - intuition. rewrite (IHe _ H0) at 1; clear IHe;simpl.
    destr_post (rm0 e) (a::A). simpl in T;rewrite<- T;auto 10.
  - intuition. rewrite (IHe _ H0) at 1; clear IHe;simpl.
    destr_post (rm0 e) (rm a A). simpl in T;rewrite<- T;auto 10.
    eql;eqr;apply eq_ax,eq_ω_bot;simpl_in;tauto.
  - intuition. rewrite (IHe _ T) at 1; clear IHe;simpl.
    destr_post (rm0 e) (p⋆⧓A). simpl in T0;rewrite<- T0;auto 10.
Qed.

(** If [e] and [f] are related by zero axioms then  *)
(** [rm0 e] and [rm0 f] are equal in a minimal setting. *)
Lemma rm0_zero_eq_u :
  Proper (ut ∧ zero_eq_u ==> eq_expr) rm0.
Proof. intros e f ((Ue & Uf)& [[E|E]|E]);destruct E;simpl in *;
       simpl_hyp;try destr_posu (rm0 e);auto;reflexivity.
Qed.

Lemma rm0_zero_eq_t :
  Proper (ty'∧ zero_eq_t ==> eq_expr) rm0.
Proof.
  intros e f ((A&Te&Tf) & [[E|E]|E]);
  destruct E;simpl in *;simpl_hyp;auto.
  ecase @eq0'_t_spec;try (apply typed_rm0;eassumption);
  try (intros (? & eq); try rewrite eq in *;simpl in * );
  intros;simpl; try reflexivity;auto.
  apply typed_rm0 in h;rewrite h0,eq in h;simpl in h;auto.
  ecase @eq0'_t_spec;try (apply typed_rm0;eassumption);
  try (intros (? & eq); try rewrite eq in *;simpl in * );
  intros;simpl; try reflexivity;auto.
  apply typed_rm0 in h;rewrite h0,eq in h;simpl in h;auto.
Qed.

(** Axiom bundles preserve [rm0]. *)
Lemma rm0_eq_ν_smpl_typed :
  Proper (ty'∧ eq_ν_smpl ==> eq eq_ν_smpl) rm0.
Proof.
  intros e f ((A & T1 & T2) & h); destruct h;simpl;auto.
  - destruct T1 as (I&Te&Tf);destr_post (rm0 e) (a::A);
    destr_post (rm0 f) (a::A);rewrite gb;auto.
  - destruct T1 as (I1&I2&T1); destr_post (rm0 e) (b::a::A);
    rewrite rm_comm;auto.
Qed.

Lemma rm0_eq_ν_smpl_untyped :
  Proper (ut ∧ eq_ν_smpl ==> eq eq_ν_smpl) rm0.
Proof.
  intros e f ((T1 & T2) & h); destruct h;simpl;auto.
  - simpl in *;simpl_hyp;
    destr_posu (rm0 e);destr_posu (rm0 f);rewrite gb;auto.
  - simpl in *;simpl_hyp;destr_posu (rm0 e);
    rewrite rm_comm;auto.
Qed.


Lemma rm0_eq_ω_smpl_typed :
  Proper (ty'∧ eq_ω_smpl ==> eq eq_ω_smpl) rm0.
Proof.
  intros e f ((A&T1&T2)&h);destruct h;simpl;auto.
  - simpl in T1;simpl_hyp;destr_post (rm0 e) (rm a A);
    destr_post (rm0 f) (rm a A);rewrite gb;auto.
  - simpl in T1;simpl_hyp;destr_post (rm0 e) (rm a A);
    destr_post (rm0 f) (rm a A).
  - simpl in T1;simpl_hyp;destr_post (rm0 e) (rm a A).
    simpl in T;rewrite <- T;assert (~In a (rm a A))
      by (simpl_in;tauto);auto.
  - simpl in T1;simpl_hyp;destr_post (rm0 e) (rm b (rm a A)).
    rewrite cons_comm;reflexivity.
Qed.    


Lemma rm0_eq_perm_elim :
  Proper ((eq_perm_elim∨eq_perm)
            ==> (Logic.eq∨eq_perm_elim∨eq_perm)) rm0.
Proof.
  intros ? ? [E|E];destruct E;try (now simpl;auto).
  - simpl; case get_bot_spec;intuition.
    simpl_perm;auto.
  - simpl;repeat case get_bot_spec;
    repeat (let h := fresh "h" in
            intro h;try rewrite h in *;simpl in * );
    try discriminate || (left;left;congruence);auto.
  - simpl;repeat case get_bot_spec;
    repeat (let h := fresh "h" in
            intro h;try rewrite h in *;simpl in * );
    try discriminate || (left;left;congruence);auto.
  - simpl;repeat case get_bot_spec;
    repeat (let h := fresh "h" in
            intro h;try rewrite h in *;simpl in * );
    try discriminate || (left;congruence);eauto.
  - simpl;repeat case get_bot_spec;
    repeat (let h := fresh "h" in
            intro h;try rewrite h in *;simpl in * );
    try discriminate || (left;left;congruence);eauto.
    left;left. inversion h2;f_equal.
    now rewrite mact_rm;simpl_perm.
  - simpl;repeat case get_bot_spec;
    repeat (let h := fresh "h" in
            intro h;try rewrite h in *;simpl in * );
    try discriminate || (left;left;congruence);eauto.
    left;left. inversion h2;f_equal.
    now rewrite mact_comp_app.
Qed.
Lemma rm0_eq_perm_ω :
  Proper ((eq_perm_ω)
            ==> (Logic.eq∨eq_perm_ω)) rm0.
Proof.
  intros ? ? E;destruct E; simpl;auto.
  case (@get_bot_spec (rm0 e));simpl;auto.
Qed.
Lemma rm0_t_ka_eq :
  Proper (ty'∧ (ka_eq∨ka_eq_t) ==> eq ka_eq_t) rm0.
Proof.
  intros e f ((A&T2&T1)& [E|E]);destruct E;simpl.
  - simpl in T1;simpl_hyp; destr_post (rm0 e) A;
    destr_post (rm0 f) A;destr_post (rm0 g) A.
  - simpl in T1;simpl_hyp; destr_post (rm0 e) A;
    destr_post (rm0 f) A; destr_post (rm0 g) A;
    rewrite eq || rewrite eq0;auto.
  - simpl in T1;simpl_hyp; destr_post (rm0 e) A;
    destr_post (rm0 f) A; simpl in *;rewrite <- T,<-T0;auto.
  - destr_post (rm0 e) A.
  - simpl in T1;simpl_hyp; destr_post (rm0 e) A;
    destr_post (rm0 f) A;destr_post (rm0 g) A;rewrite eq0;auto.
  - simpl in T1;simpl_hyp; destr_post (rm0 e) A;
    destr_post (rm0 f) A;destr_post (rm0 g) A;rewrite eq;auto.
    simpl in *;rewrite <- T1,<-T0;auto.
  - destr_post (rm0 e) A0.
  - destr_post (rm0 e) A0.
  - destr_post (rm0 e) A0; simpl in T;rewrite <- T;auto.
  - destr_post (rm0 e) A0; simpl in T;rewrite <- T;auto. 
Qed.

Lemma rm0_u_ka_eq :
  Proper (ut ∧ (ka_eq∨ka_eq_u) ==> eq ka_eq_u) rm0.
Proof.
  intros e f ((T2&T1)& [E|E]);destruct E;simpl.
  - simpl in T1;simpl_hyp; destr_posu (rm0 e);
    destr_posu (rm0 f);destr_posu (rm0 g).
  - simpl in T1;simpl_hyp; destr_posu (rm0 e);
    destr_posu (rm0 f); destr_posu (rm0 g);
    rewrite eq || rewrite eq0;auto.
  - simpl in T1;simpl_hyp; destr_posu (rm0 e);
    destr_posu (rm0 f); simpl in *;rewrite <- T,<-T0;auto.
  - destr_posu (rm0 e).
  - simpl in T1;simpl_hyp; destr_posu (rm0 e);
    destr_posu (rm0 f);destr_posu (rm0 g);rewrite eq0;auto.
  - simpl in T1;simpl_hyp; destr_posu (rm0 e);
    destr_posu (rm0 f);destr_posu (rm0 g);rewrite eq;auto.
  - destr_posu (rm0 e).
  - destr_posu (rm0 e).
  - destr_posu (rm0 e); simpl in T;rewrite <- T;auto.
  - destr_posu (rm0 e); simpl in T;rewrite <- T;auto. 
Qed.

Lemma rm0_eq_nom_untyped_p :
  Proper (ut ∧ (eq_nom_untyped_p) ==> eq eq_nom_untyped_p) rm0.
Proof.
  intros e f ((Ue&Uf)&E).
  assert (U1 : untyped (rm0 e)) by (now apply untyped_rm0);
    assert (U2 : untyped (rm0 f)) by (now apply untyped_rm0).
  destruct E;simpl in *;simpl_hyp; apply fresh_rm0 in H;auto.
  revert U1 U2;case get_bot_spec;simpl;firstorder (auto;prove_ax).
Qed.
Lemma rm0_eq_nom_untyped_np :
  Proper (ut ∧ (eq_nom_untyped_np) ==> eq eq_nom_untyped_np) rm0.
Proof.
  intros e f ((Ue&Uf)&E); destruct E; simpl in *.
  apply fresh_rm0 in H;auto.
  destr_posu (rm0 e).
  destr_posu (rm0  ([a, b] • e)).
  rewrite rm0_apply_perm,h in *;simpl;auto.
  simpl in *;discriminate.
  rewrite rm0_apply_perm;case (rm0_eq0_get_bot _ (rm0_involutive e)).
  tauto.
  intros ? E;apply untyped_rm0 in Ue;rewrite E in Ue;simpl in Ue;tauto.
  intro;prove_ax.
Qed.
Lemma rm0_eq_nom_untyped :
  Proper (ut ∧ (eq_nom_untyped) ==> eq eq_nom_untyped) rm0.
Proof.
  intros e f ((Ue&Uf)&E).
  destruct E;simpl in *;simpl_hyp;apply fresh_rm0 in H;auto;
  destr_posu (rm0 e);try destr_posu (rm0 f). 
Qed.
Lemma rm0_eq_nom_typed :
  Proper (ty'∧ (eq_nom_typed) ==> eq eq_nom_typed) rm0.
Proof.
  intros e f ((A&Te&Tf)&E); destruct E.
  - simpl in *;simpl_hyp;repeat simpl_beq;simpl in*.
    destr_post (rm0 e) (rm a A);try simpl_beq;simpl.
    simpl in T;rewrite<- T,rm_id by (now simpl_in);auto.
    eapply eq_ax,(@eqt_νω1 A);simpl;simpl_beq;simpl;tauto.
  - simpl in *;simpl_hyp;
    destr_post (rm0 e) (rm b (a::A));try simpl_beq;simpl;auto.
  - simpl in *;simpl_hyp;simpl_beq;simpl in*.
    rewrite rm_id in h3 by tauto.
    destr_post (rm0 e) A;destr_post (rm0 f) (a::A).
    simpl_beq;simpl in *;rewrite <-T;auto;rewrite rm_id;auto.
  - simpl in *;simpl_hyp;simpl_beq;simpl in*.
    rewrite rm_id in h3 by tauto.
    destr_post (rm0 e) A;destr_post (rm0 f) (a::A);
    simpl_beq;simpl in *;rewrite <-T;auto;rewrite rm_id;auto.
Qed.
Lemma rm0_eq_nom_typed_p :
  Proper (eq_nom_typed_p ==> eq eq_nom_typed_p) rm0.
Proof.
  intros e f E;destruct E. simpl in *;simpl_hyp.
  destr_post (rm0 e) (a::A).
  - simpl in T;rewrite <-T.
    case_eq_at a b;simpl;repeat simpl_beq;simpl;
    rewrite mact_id1 || rewrite mact_id2,rm_id,rm_id;auto.
  - prove_ax;apply (@eqt_θν' A);simpl;split_conj;auto.
Qed.
Lemma stronger_Ty_eq_nom_typed_np :
  eq_nom_typed_np ⇒ ty'∧ eq_nom_typed_np.
Proof.
  intros ? ? E. destruct E as [X a b e [J T'] I].
  split;[exists X;simpl;split_conj|apply (@eqt_θν X)];auto.
  apply has_type_apply_perm;simpl;simpl_beq;rewrite mact_id2;auto.
Qed.
  
Lemma rm0_eq_nom_typed_np :
  Proper (eq_nom_typed_np ==> eq (eq_nom_typed_np)) rm0.
Proof.
  intros ? ? [X a b e [J T] I].
  pose proof (typed_rm0 T) as T'.
  simpl;destr_post (rm0 e) (a::X).
  simpl in *;rewrite rm0_apply_perm,h;simpl;rewrite <-T'.
  case_eq_at a b;simpl;repeat simpl_beq;simpl;
  [rewrite mact_id1|rewrite mact_id2];repeat rewrite rm_id;auto.
  rewrite <- (eq0'_rm0_apply_perm _ [b,a]) in eq.
  case get_bot_spec.
  intros E;rewrite E in eq;discriminate.
  intros ? E;rewrite E in eq;discriminate.
  intros _. rewrite rm0_apply_perm.
  apply eq_ax,(@eqt_θν X);auto.
Qed.
Lemma untyped_impl_rm0 (ax ax0 :expr -> expr -> Prop):
  (Proper ((ax∨ax0) ==> iff) untyped) ->
  (Proper ((ax∨ax0) ==> Logic.eq) eq0) ->
  ka_eq_u ⇒ ax ->
  (Proper (ut ∧ ax ==> eq ax) rm0) ->
  (Proper (ut ∧ ax0 ==> eq_expr) rm0) ->
  (Proper (ut ∧ (eq (ax∨ax0)) ==> eq (ut ∧ ax)) rm0).
Proof.
  intros Pu Peq0 Pka Prm Prm0 ? ? (U&E).
  apply remain_Ut.
  intros e f H; assert (I:(ax∨ax0) e f) by (now left);
  apply (Pu e f I).
  destruct U;auto using untyped_rm0.
  unfold ut,rel in *;
  pose proof (eq_untyped Pu) as PU;unfold Proper,respectful in PU.
  induction E;try (now simpl;intuition).
  - rewrite IHE1, IHE2;firstorder.
  - destruct U as ((U1 & U2) & (U3 & U4)).
    pose proof (eq_eq0 Peq0 E1) as E3;pose proof (eq_eq0 Peq0 E2) as E4.
    repeat rewrite eq0_rm0_u in E3,E4;simpl.
    destr_posu (rm0 e);simpl in *;rewrite <-E3;
    [|destr_posu (rm0 g);simpl in *;rewrite <-E4];intuition.
  - destruct U as ((U1 & U2) & (U3 & U4)).
    pose proof (eq_eq0 Peq0 E1) as E3;pose proof (eq_eq0 Peq0 E2) as E4.
    repeat rewrite eq0_rm0_u in E3,E4;simpl.
    destr_posu (rm0 e);simpl in *;rewrite <-E3;
    [|destr_posu (rm0 g);simpl in *;rewrite <-E4];intuition.
  - destruct U as (U1 & U2);simpl in U1,U2;
    pose proof (eq_eq0 Peq0 E) as E2;repeat rewrite eq0_rm0_u in E2.
    simpl;destr_posu (rm0 e); destr_posu (rm0 f);simpl in *;
    discriminate.
  - destruct U as (U1 & U2);simpl in U1,U2;
    pose proof (eq_eq0 Peq0 E) as E2;repeat rewrite eq0_rm0_u in E2.
    simpl;destr_posu (rm0 e); destr_posu (rm0 f);
    simpl in *;discriminate.
  - destruct U as (U1 & U2);simpl in U1,U2;
    pose proof (eq_eq0 Peq0 E) as E2;repeat rewrite eq0_rm0_u in E2.
    simpl;destr_posu (rm0 e); destr_posu (rm0 f);
    simpl in *; discriminate.
  - destruct U as (U1 & U2);simpl in U1,U2.
    eapply stronger_ax_proof;[|apply rm0_u_ka_eq;split];auto.
  - destruct H;destruct U as (((U1&U2)&_)&Ug);simpl in U1,U2;
    pose proof (eq_eq0 Peq0 E) as E2;repeat rewrite eq0_rm0_u in E2.
    * assert (ax ⊢ rm0 (f + e ·g + g) ≡ rm0 g) as Eq
          by (apply IHE;split;simpl;tauto);clear IHE E.
       simpl in *;destr_posu (rm0 e);simpl in *;destr_posu (rm0 f);
       simpl in *;destr_posu (rm0 g);simpl in *.
        rewrite eq in E2;discriminate.
        transitivity (rm0 f + rm0 g);auto. 
        repeat rewrite eq0 in E2;discriminate.
        eapply eq_ka_impl;eauto.
    * assert (ax ⊢ rm0 (f + g·e + g) ≡ rm0 g) as Eq
          by (apply IHE;split;simpl;tauto);clear IHE E.
       simpl in *;destr_posu (rm0 e);simpl in *;destr_posu (rm0 f);
       simpl in *;destr_posu (rm0 g);simpl in *.
        repeat rewrite eq in E2;discriminate.
        rewrite eq in Eq;transitivity (rm0 f + rm0 g);auto.
        repeat rewrite eq0 in E2;discriminate.
        eapply eq_ka_impl;eauto.
  - destruct H as [E|E].
    * apply Prm;split;auto.
    * eapply stronger_ax_proof;[intro| apply eq_expr_eq, Prm0;split];intuition;eauto.
Qed.
Lemma typed_impl_rm0 (ax ax0 :expr -> expr -> Prop):
  (forall A,Proper ((ax∨ax0) ==> iff) ( has_type A)) ->
  (Proper ((ax∨ax0) ==> Logic.eq) eq0) ->
  ka_eq_t ⇒ ax ->
  (Proper (ty'∧ ax ==> eq ax) rm0) ->
  (Proper (ty'∧ ax0 ==> eq_expr) rm0) ->
  (Proper (ty'∧ (eq (ax∨ax0)) ==> eq (ty'∧ ax)) rm0).
Proof.
  intros hT heq0. apply eq_eq0 in heq0.
  pose proof (eq_type hT) as hU. 
  intros KA Ax Ax0 e f ((A&Ue&Uf)&E).
  apply remain_Ty with (A:=A);auto using typed_rm0.
  intros X x y H; apply (hT X x y);now left.
  clear hT;revert A Ue Uf;induction E;
  intros X Ue Uf;try (now simpl;auto).
  - rewrite IHE;eauto.
  - transitivity (rm0 f);[eapply IHE1|eapply IHE2];eauto;
    eapply hU;eauto.
  - simpl. repeat rewrite <-eq0_rm0_u; repeat rewrite (heq0 _ _ E1);
    repeat rewrite (heq0 _ _ E2); case (eq0 f);[|case (eq0 h)];
    simpl in *;intuition eauto.
  - simpl. repeat rewrite <-eq0_rm0_u; repeat rewrite (heq0 _ _ E1);
    repeat rewrite (heq0 _ _ E2); case (eq0 f);[|case (eq0 h)];
    simpl in *;intuition eauto.
  - simpl in *;pose proof (IHE X Ue Uf).
    apply typed_rm0 in Ue;apply typed_rm0 in Uf.
    simpl_get_bot;simpl_get_bot;simpl in *;try tauto||auto.
    * rewrite <- Ue,<-Uf;auto.
    * apply heq0 in E;rewrite eq0_rm0_u,eq0_rm0_u,h,h0 in E.
       discriminate.
    * apply heq0 in E;rewrite eq0_rm0_u,eq0_rm0_u,h,h0 in E.
       discriminate.
  - simpl in *;destruct Ue as (?&Ue);destruct Uf as (?&Uf);
    pose proof (IHE _ Ue Uf).
    apply typed_rm0 in Ue;apply typed_rm0 in Uf.
    simpl_get_bot;simpl_get_bot;simpl in *;try tauto||auto.
    * rewrite <- Ue,<-Uf;auto.
    * apply heq0 in E;rewrite eq0_rm0_u,eq0_rm0_u,h,h0 in E.
       discriminate.
    * apply heq0 in E;rewrite eq0_rm0_u,eq0_rm0_u,h,h0 in E.
       discriminate.
  - simpl in *.
    rewrite <-(equiv_perm_mact _ _ (equiv_perm_inverse H)) in Uf.
    pose proof (IHE _ Ue Uf).
    apply typed_rm0 in Ue;apply typed_rm0 in Uf.
    simpl_get_bot;simpl_get_bot;simpl in *;try tauto ||auto.
    * rewrite <- Ue,<-Uf, <-(equiv_perm_mact _ _ H);auto.
    * apply heq0 in E;rewrite eq0_rm0_u,eq0_rm0_u,h,h0 in E.
       discriminate.
    * apply heq0 in E;rewrite eq0_rm0_u,eq0_rm0_u,h,h0 in E.
       discriminate.
  - simpl in *;destruct Ue as (?&Ue);destruct Uf as (?&Uf);
    pose proof (IHE _ Ue Uf).
    apply typed_rm0 in Ue;apply typed_rm0 in Uf.
    simpl_get_bot;simpl_get_bot;simpl in *;try tauto||auto.
    * rewrite <- Ue,<-Uf;auto.
    * apply heq0 in E;rewrite eq0_rm0_u,eq0_rm0_u,h,h0 in E.
       discriminate.
    * apply heq0 in E;rewrite eq0_rm0_u,eq0_rm0_u,h,h0 in E.
       discriminate.
  - destruct H;simpl;
    remember (eq0' (rm0 e)) as b1; try remember (eq0' (rm0 f)) as b2;
    try remember (eq0' (rm0 g)) as b3;
    destruct b1;try destruct b2;try destruct b3;
    repeat (rewrite<- Heqb1||rewrite<- Heqb2||rewrite<- Heqb3);
    simpl;auto;
    simpl in *;simpl_hyp;revert Heqb1 Heqb2;try revert Heqb3;
    repeat (ecase eq0'_t_spec;[eauto using typed_rm0| |discriminate]).
    * apply typed_rm0 in h;apply typed_rm0 in h0.
       intros (? & eq1) (? & eq2);rewrite eq1 in *;rewrite eq2 in *;
       eauto.
    * (ecase eq0'_t_spec;[eauto using typed_rm0| discriminate| ]).
       (ecase eq0'_t_spec;[eauto using typed_rm0| |discriminate]).
       apply typed_rm0 in h2;apply typed_rm0 in h0.
       intros (? & eq1) _ (? & eq2);rewrite eq1 in *;rewrite eq2 in *;
       eauto.
       apply typed_rm0 in h1;rewrite eq1 in h1;simpl in *. eauto.
  - apply (hU _ _ _ E) in Uf;destruct Ue as (Ue & _).
    simpl in Uf;destruct Uf as (Uf & Ug).
    assert (ax ⊢ rm0 (e + g) ≡ rm0 g) as HH
        by (eapply IHE;simpl;eauto);clear IHE;revert HH.
    pose proof (heq0 _ _ E) as PP;revert PP.
    simpl;repeat rewrite eq0_rm0_u.
    pose proof (typed_rm0 Ue) as Te;pose proof (typed_rm0 Uf) as Tf;
    pose proof (typed_rm0 Ug) as Tg;revert Te Tf Tg.
    destruct H;simpl in *;simpl_hyp.
    * ecase get_bot_t_spec ;[eauto using typed_rm0|tauto|intros ? ->|];
       simpl.
        simpl; ecase (@eq0'_t_spec (rm0 f));
           [eauto using typed_rm0 | intros ( ? & -> ) | ];
           simpl;auto;
           ecase (@eq0'_t_spec (rm0 g));
           [eauto using typed_rm0|intros (?&->)|];
           simpl;auto;
           ecase (@eq0'_t_spec (rm0 f));
           try (eapply typed_rm0;eassumption)
           || tauto || discriminate.
          intros _ _ _ (Eq&Tf) _ Tg _ P; rewrite Eq in *;
          rewrite <-P at 2;auto.
        intro Eq;rewrite Eq;simpl.
           ecase (@eq0'_t_spec (rm0 f));
             [eauto using typed_rm0
             | intros ( ? & Eqf );rewrite Eqf in * | ];simpl;auto.
           ecase (@eq0'_t_spec (rm0 g));
             [eauto using typed_rm0|intros (?&->)|];
             simpl;eauto;
             ecase (@eq0'_t_spec (rm0 f));
             try (eapply typed_rm0;eassumption)
             || tauto || discriminate.
    * ecase get_bot_t_spec ;[eauto using typed_rm0|tauto|intros ? ->|];
       simpl.
        simpl; ecase (@eq0'_t_spec (rm0 f));
           [eauto using typed_rm0 | intros ( ? & -> ) | ];
           simpl;auto;
           ecase (@eq0'_t_spec (rm0 g));
           [eauto using typed_rm0|intros (?&->)|];
           simpl;auto;
           ecase (@eq0'_t_spec (rm0 f));
           try (eapply typed_rm0;eassumption)
           || tauto || discriminate.
        intros _ _ _ (_&Eq) Tf Tg _ P; rewrite Eq in *;
        rewrite <-P at 2;auto.
        intro Eq;rewrite Eq;simpl.
           ecase (@eq0'_t_spec (rm0 f));
             [eauto using typed_rm0
             | intros ( ? & Eqf );rewrite Eqf in * | ];simpl;auto.
           ecase (@eq0'_t_spec (rm0 g));
             [eauto using typed_rm0|intros (?&->)|];
             simpl;eauto;
             ecase (@eq0'_t_spec (rm0 f));
             try (eapply typed_rm0;eassumption)
             || tauto || discriminate.
  - destruct H as [H|H].
    * eapply Ax;split;[eexists;split|];eassumption.
    * eapply eq_expr_eq. unfold stronger;intuition.
       eapply Ax0;split;[eexists;split|];eassumption.
Qed.

Theorem typed_equiv_rm0 (ax ax0 :expr -> expr -> Prop):
  (forall A,Proper ((ax∨ax0) ==> iff) ( has_type A)) ->
  (Proper ((ax∨ax0) ==> Logic.eq) eq0) ->
  ka_eq_t ⇒ ax -> zero_eq_t ⇒ ax0 ->
  (Proper (ty'∧ ax ==> eq ax) rm0) ->
  (Proper (ty'∧ ax0 ==> eq_expr) rm0) ->
  forall e f, (exists A,A ⊨ e) -> (exists A, A ⊨ f) ->
                ((ax∨ax0) ⊢ e ≡ f <-> ax ⊢ (rm0 e) ≡ (rm0 f)).
Proof.
  intros h1 h2 h3 h4 h5 h6 e f (A&Te) (B&Tf).
  pose proof (eq_type h1).
  split;intros E.
  - apply (@stronger_ax_proof (ty'∧ax)).
    autounfold;intuition.
    eapply typed_impl_rm0;eauto;intros.
    split;auto.
    exists A;split;auto.
    apply (eq_type h1 A E);auto.
  - pose proof (rm0_eq_typed Te) as E1.
    pose proof (rm0_eq_typed Tf) as E2.
   transitivity (rm0 e);[|symmetry;transitivity (rm0 f);[|symmetry]].
    eapply stronger_ax_proof;[|apply E1].
    intro;unfold or_rel;intuition.
    eapply stronger_ax_proof;[|apply E2].
    intro;unfold or_rel;intuition.
    eapply stronger_ax_proof;[|apply E].
    intro;unfold stronger,or_rel;intuition.
Qed.

Theorem untyped_equiv_rm0 (ax ax0 :expr -> expr -> Prop):
  (Proper ((ax∨ax0) ==> iff) untyped) ->
  (Proper ((ax∨ax0) ==> Logic.eq) eq0) ->
  ka_eq_u ⇒ ax -> zero_eq_u ⇒ ax0 ->
  (Proper (ut ∧ ax ==> eq ax) rm0) ->
  (Proper (ut ∧ ax0 ==> eq_expr) rm0) ->
  forall e f, untyped e -> untyped f ->
              ((ax∨ax0) ⊢ e ≡ f <-> ax ⊢ (rm0 e) ≡ (rm0 f)).
Proof.
  intros h1 h2 h3 h4 h5 h6 e f Te Tf.
  pose proof (eq_untyped h1).
  split;intros E.
  - apply (@stronger_ax_proof (ut ∧ ax)).
    autounfold;intuition.
    eapply untyped_impl_rm0;eauto;intros.
    split;auto.
  - pose proof (rm0_eq_untyped Te) as E1.
    pose proof (rm0_eq_untyped Tf) as E2.
    transitivity (rm0 e);[|symmetry;transitivity (rm0 f);[|symmetry]].
    eapply stronger_ax_proof;[|apply E1].
    unfold or_rel;intro;intuition.
    eapply stronger_ax_proof;[|apply E2].
    unfold or_rel;intro;intuition.
    eapply stronger_ax_proof;[|apply E].
    unfold ut,or_rel;intro;intuition.
Qed.
